<?php
if ( ! class_exists( 'IPSocialLocker_Db' )) {

    /**
     * Class for manage plugin database
     */
    class IPSocialLocker_Db
    {
        /**
         * Take db version
         *
         * @var string
         */
        public $version = '1.0';
        
        /**
         * Class construct
         *
         * @return void
         */
        public function __construct()
        {
            global $iplocker_db_version;
            $iplocker_db_version = $this->version;
        }
        
        /**
         * Database query
         *
         * @return string
         */
        public function query()
        {
            global $wpdb;
            
            $table_name = $wpdb->prefix . 'ip_social_tracking';
            $sql = "CREATE TABLE $table_name (
  id int(11) NOT NULL AUTO_INCREMENT,
  aggregate_date date DEFAULT '0000-00-00' NOT NULL,
  post_id int(11) NOT NULL,
  total_count int(11) DEFAULT 0 NOT NULL,
  facebook_like_count int(11) DEFAULT 0 NOT NULL,
  facebook_share_count int(11) DEFAULT 0 NOT NULL,
  twitter_tweet_count int(11) DEFAULT 0 NOT NULL,
  twitter_follow_count int(11) DEFAULT 0 NOT NULL,
  google_plus_count int(11) DEFAULT 0 NOT NULL,
  google_share_count int(11) DEFAULT 0 NOT NULL,
  linkedin_share_count int(11) DEFAULT 0 NOT NULL,
  timer_count int(11) DEFAULT 0 NOT NULL,
  close_count int(11) DEFAULT 0 NOT NULL,
  PRIMARY KEY  id (id),
  KEY post_id (post_id)
);";    

            return $sql;
        }
        
        /**
         * install
         *
         * @return void
         */
        public function install()
        {
            global $wpdb, $iplocker_db_version;
            $installed_ver = get_option( "iplocker_db_version" );
            
            if( ! $installed_ver || ( $installed_ver != $iplocker_db_version ) ) {

                $sql = $this->query();

                require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
                dbDelta( $sql );

                update_option( "iplocker_db_version", $iplocker_db_version );
            }
        }
        
        /**
         * update
         *
         * @return void
         */
        public function update()
        {
            global $iplocker_db_version;
            if ( get_site_option( 'iplocker_db_version' ) != $iplocker_db_version ) {
                $this->install();
            }
        }
    }

}
?>