/**
 * Menu control
 **/
var ipsl_do_get_preview = null;

(function($){

    $.fn.ipsl_save_setting = function(options) {
        
        var defaults  = {
            saveAdd: true
        };
        var options = $.extend( defaults, options );
        
        var link  = $(this);
        link.click( function() {
        
            link.attr( 'disabled', 'disabled' );
            $( '#ipsl-form-submit .spinner' ).show();
            var formdata = ipsl_getdataform( $( '#ipsl-manage-form' ) );
            
            var socorder = '';
            $( '.ipsl-tab-menu li' ).each( function(){
            
                socorder += $(this).attr( 'id' ).replace( 'ipsl-link-', '' );
                socorder += '|';
            });
            formdata += '&socorder='+socorder;
            
            $.ajax({
                url: ajaxurl+'?doajax=1&iplocker=1&action=iplocker_save',
                type: "POST",
                data: formdata,
                dataType: "json",
                success: function ( result ) {
                    if ( options.saveAdd ) {
                        if ( result.status == 1 ) {
                            window.location.href = 'admin.php?page=wp-sociallocker&action=edit&id='+result.id;
                        }
                    }
                    link.removeAttr( 'disabled');
                    $( '#ipsl-form-submit .spinner' ).hide();
                    $( '#ipsp-locker-id' ).val( result.id );
                },
            });
            return false;
        });
        
    };
    
    function ipsl_getdataform( parent ) 
    {
        var selector  = 'input[type=text]';
        selector += ', input[type=hidden]';
        selector += ', input[type=password]';
        selector += ', input[type=radio]:checked';
        selector += ', input[type=checkbox]:checked';
        selector += ', textarea';
        selector += ', select';
        
        var data = '';
        
        $( selector, parent ).each( function(){
            var name  = $(this).attr( 'name' );
            var value = encodeURIComponent( $(this).val() );
            
            if ( data != '' ) {
                data += '&';
            }
            data += name+'='+value;
        });
        for ( edId in tinymce.editors ) {
            
            if ( edId.length > 1 ) {
                var value = tinymce.editors[edId].getContent();
                if ( data != '' ) {
                    data += '&';
                }
                data += edId+'='+value;
            }
        }
        return data;
    };
    
    ipsl_do_get_preview = function()
    {
        var form = $('#ipsl-manage-form');
        var data = ipsl_getdataform( form );
        var socorder = '';
        $( '.ipsl-tab-menu li' ).each( function(){
        
            socorder += $(this).attr( 'id' ).replace( 'ipsl-link-', '' );
            socorder += '|';
        });
        data += '&socorder='+socorder;
        
        $.ajax({
            url: ajaxurl+'?doajax=1&iplocker=1&action=iplocker_preview',
            type: "POST",
            data: data,
            dataType: "json",
            success: function ( result ) {
                if ( result.preview ) {
                    $('#ipsl-locker-preview', form).removeClass( 'nopreview' );
                    $('#ipsl-locker-preview', form).html( result.preview );
                }
            },
        });
    }
   
    $(document).ready(function() {
        
    
        ipsl_get_preview = function() 
        {
            var form = $('#ipsl-manage-form');
            
            //Input text
            $( 'input[type="text"]', form ).focusout( function(){
                ipsl_do_get_preview();
            });
            
            //Input radio
            $( 'input[type="radio"]', form ).click( function(){
                ipsl_do_get_preview();
            });
            
            //Input select
            $( 'select', form ).change( function(){
                ipsl_do_get_preview();
            });
        };
        ipsl_get_preview();
    
        //Tab menu
        $( '.ipsl-tab-menu li:first-child' ).addClass( 'active' );
        $( '.ipsl-tab-item' ).hide();
        $( '.ipsl-tab-item:first-child' ).show();
        
        $( '.ipsl-tab-menu a' ).click( function(){
            
            var link = $(this);
            var href = link.attr( 'href' );
            
            $( '.ipsl-tab-menu li' ).removeClass( 'active' );
            link.parent().addClass( 'active' );
            
            $( '.ipsl-tab-item' ).hide();
            $( href ).show();
            
            return false;
        });
        
        //Img preview hover
        var ipsl_current_prv = false;
        $( '.ipsl-prv-thumb img' ).hover( 
            function(){
                var parent  = $(this).parents( 'li' );
                var prv     = $( '.ipsl-prv-big', parent );
                var offset  = parent.offset();
                var height  = parent.height();
                var prvh    = prv.height();
                
                $('body').append( prv );
                prv.css( 'position', 'absolute' )
                   .css( 'display', 'block' )
                   .css( 'left', offset.left )
                   .css( 'top', offset.top + height )
                   .css( 'z-index', '9999' )
                   .show();
                
                ipsl_current_prv = prv;
            }, 
            function(){
                if ( ipsl_current_prv ) {
                    var parent  = $(this).parents( 'li' );
                    var prv     = $( '.ipsl-prv-big', parent );
                    var offset  = parent.offset();
                    
                    ipsl_current_prv.hide();
                    $( 'label', parent ).append( ipsl_current_prv );
                    ipsl_current_prv = false;
                }
            }
        );
        
        //Publish
        $( '.ipsl-publish' ).ipsl_save_setting();
        
        //Update
        $( '.ipsl-update' ).ipsl_save_setting({
            'saveAdd': false
        });
        
        //Button radio
        $( '#ipsl-advfunc-field .ipsl-btn-radio button' ).click( function(){
        
            var root  = $(this).parents( '.ipsl-btn-radio' );
            var value = $(this).data( 'value' );
            if ( ! $(this).hasClass( '.active' ) ) {
                $( 'button', root ).removeClass( 'active' );
                $( 'button', root ).removeClass( 'button-primary' );
                $(this).addClass( 'button-primary active' );
            }
            $( '.ipsl-av-value', root ).val(value);
            ipsl_do_get_preview();
        });
        
        //Button radio
        $( '.ipsl-field-buttons .ipsl-btn-radio button' ).click( function(){
        
            var root  = $(this).parents( '.ipsl-btn-radio' );
            var value = $(this).data( 'value' );
            if ( ! $(this).hasClass( '.active' ) ) {
                $( 'button', root ).removeClass( 'active' );
                $( 'button', root ).removeClass( 'button-primary' );
                $(this).addClass( 'button-primary active' );
            }
            $( '.ipsl-av-value', root ).val(value);
            
            var content = $(this).parents( '.ipsl-tab-item' );
            var cid     = content.attr( 'id' ).replace( 'ipsl-setting-','');
            if ( value == false ) {
                $( '#ipsl-link-'+cid).addClass( 'ipsl-social-off' );
            } else {
                $( '#ipsl-link-'+cid).removeClass( 'ipsl-social-off' );
            }
            ipsl_do_get_preview();
        });
        
        //Sortable
        if ( $( '.ipsl-sortable' ).length > 0 ) {
            $( '.ipsl-sortable' ).sortable({
                update: function( event, ui ) {
                    ipsl_do_get_preview();
                }
            });
        }
        
        //Design Option
        $( '.ipsl-pb-section h4' ).click( function(){
        
            var root = $(this).parents( '.ipsl-pb-section' );
            if ( root.hasClass( 'active' )) {
                $( '.ipsl-pb-options', root ).hide();
                root.removeClass( 'active' );
            } else {
                $( '.ipsl-pb-options', root ).show();
                root.addClass( 'active' );
            
            }
        });
       
        //Delete locker
        $( '.ip_lockerDelete' ).each( function(){
            
            var button = $(this);
            button.click( function(){
            
                var id = button.attr( 'href' ).replace( '#toDeleteLocker_', '' );
                $( '.ipsl_loader_small' ).remove();
                button.addClass( 'button-disabled' );
                button.attr( 'disabled', 'disabled' );
                var loader = '<div class="ipsl_loader_small"></div>';
                button.after( loader );
                
                $.ajax({
                    url: ajaxurl,
                    type: "POST",
                    dataType: "json",
                    data: 'doajax=1&iplocker=1&action=iplocker_delete&id='+id,
                    success: function (result) {
                        
                        if ( result.status == '-1' ) {
                            ipsl_setMessage( 'Failed to remove the locker', 'error' );
                        } else {
                            ipsl_setMessage( 'Successfully remove the locker', 'updated' );
                            var tr = button.parents( 'tr' );
                            tr.hide( 'blind' );
                            setTimeout( function(){
                                tr.remove();
                            }, 600);
                        }
                        button.removeClass( 'button-disabled' );
                        button.removeAttr( 'disabled', 'disabled' );
                        jQuery( '.ipsl_loader_small' ).remove();
                        
                    },
                    error: function () {
                        alert( "Error in Deleting locker" );
                    },
                });
                
                return false;
            });
        });
    
        function ipsl_setMessage( msg, type ) 
        {
            var pos = jQuery( '#wpbody-content' ).position();
            jQuery('html, body').animate({scrollTop: ( pos.top )}, 1000);
            
            jQuery( '#ipsp_messages #message' ).remove();
            var msgHtml = '<div id="message" class="' + type + ' below-h2">'
            msgHtml += '<p>' + msg + '</p>';
            msgHtml += '</div>';
            
            jQuery( '#ipsp_messages' ).append( msgHtml );
        }
        
        function ipsl_setInputMessage( msg, type, input ) 
        {
            jQuery( '.inputMsg' ).remove();
            var msgHtml = '<div class="inputMsg ' + type + '">'
            msgHtml += '<p>' + msg + '</p>';
            msgHtml += '</div>';
            
            jQuery( input ).before( msgHtml );
        }
        
    });
    
})(jQuery);

function iplocker_editor_callback(e) {
    if ( e.type == 'keyup') {
        tinyMCE.activeEditor.save();
        ipsl_do_get_preview();
    }
    return true;
}