/**
 * Code in this file to be part of the wordpress plugin WP Social Locker developed by InstaProduct
 *
 * Some sections of code in this file extend existing functionality in the 
 * Social Locker for jQuery (http://codecanyon.net/item/social-locker-for-jquery/3408941) 
 * by OnePress (http://onepress-media.com/portfolio) with the permission of the developer Social Locker for jQuery.
 *
 * License of all codes in this file will be associated with the license held by the Social Locker for JQuery. 
 * Details license can be seen on http://codecanyon.net/licenses/extended
 */
(function($){
  "use strict";

    $.ipsoclocker = {};
    
    $.ipsoclocker.options = {
        
        highlight: true,
    };
    
    $.ipsoclocker.locker = {
    
        lock: function( object ){
        
        },
        
        unlock: function( object ){
        
            var object  = $(object);
            var locker  = $( '.ip-locker', object);
            var content = $( '.iplock-content-wrapper', object);
            
            object.addClass( 'iplock-show' );
            
            $.ipsoclocker.locker.alert( object );
            
            if ( object.hasClass( 'iplock-support-ajax' ) ) {
            
                var lockerId = $(object).attr( 'id' ).replace( 'iplocker-', '' );
                var postId   = $(object).data( 'postid' );
                $.ajax({
                    url: ajaxurl+'?doajax=1&iplocker=1&action=iplocker_getcontent&post_id='+postId+'&locker_id='+lockerId,
                    type: "POST",
                    processData: false,
                    contentType: false,
                    dataType: "json",
                    success: function ( result ) {
                        
                        if ( result.content ) {
                            
                            $( '.iplock-content-ajax', content ).html( result.content );
                            
                            if ( $.ipsoclocker.options.highlight == 'true' ) {
                            
                                //Animated locker
                                locker.css( 'opacity', '1' );
                                locker.css( 'background-color', '#ffff66' );
                                locker.animate({opacity: "0", backgroundColor: "transparent"}, 1000, function(){
                                    locker.hide();
                                });
                                //Animated content
                                content.css( 'opacity', '0' );
                                content.show();
                                content.animate({opacity: "1"}, 1200);
                            
                            } else {
                                locker.hide();
                                content.show(); 
                            }
                        }
                    }
                });
            
            } else {
            
                if ( $.ipsoclocker.options.highlight == 'true' ) {
                    //Animated locker
                    locker.css( 'opacity', '1' );
                    locker.css( 'background-color', '#ffff66' );
                    locker.animate({opacity: "0", backgroundColor: "transparent"}, 1000, function(){
                        locker.hide();
                    });
                    //Animated content
                    content.css( 'opacity', '0' );
                    content.show();
                    content.animate({opacity: "1"}, 1200, function(){
                        $( '.iplock-content-inner', content ).show();
                    });
                }
                else {
                    locker.hide();
                    content.show();
                    $( '.iplock-content-inner', content ).show();
                }
            
            }
        },
    
        log: function( object, type ){
        
            var lockerId = $(object).attr( 'id' ).replace( 'iplocker-', '' );
            var postId   = $(object).data( 'postid' );
            $.ajax({
                url: ajaxurl+'?doajax=1&iplocker=1&action=iplocker_log&post_id='+postId+'&locker_id='+lockerId+'&type='+type,
                type: "POST",
                processData: false,
                contentType: false,
                dataType: "json",
                success: function ( result ) {
                }
            });
        },
        
        setCookie: function( object ) {
        
            var lockerId = $(object).attr( 'id' ).replace( 'iplocker-', '' );
            var expires  = new Date();
            var key      = 'iplocker_open_id'+lockerId;
            var date     = expires.toUTCString();
            
            expires.setTime(expires.getTime() + (30 * 24 * 60 * 60 * 1000));
            document.cookie = key + '=' + date + ';expires=' + expires.toUTCString();
        },
        
        alert: function( object ) {
        
            if ( object.hasClass( 'iplock-support-alert' )) {
                var msg = $( '.ipsl-alert-message', object ).text();
                alert( msg );
            }
            
        }
    };
    
    $.ipsoclocker.factory = {
    
        //Facebook like button
        facebooklike: {
        
            options: {},

            defaults: {
                
                url:            null,
                appId:          0,
                lang:           'en_US',
                layout:         'standart',
                width:          'auto',
                verbToDisplay:  "like",
                colorScheme:    "light",
                font:           'tahoma',
                ref:            null,
                count:          'standart',
                
                // unlock event
                unlock:         null
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();

                this.element.data('ipsoclocker-facebookButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("facebook", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values   = $.extend({}, this.defaults);
                this.options = $.extend(values, this.options);
                this.url     = (!this.options.url) ? window.location.href : this.options.url;
            },

            setupEvents: function () {
                var self = this;

                $(document).bind('fb-like', function (e, url) {
                    if ( self.url == url ) {
                        var widget = self.element;
                        var item   = widget.parents( '.iplock-item' );
                        $.ipsoclocker.locker.unlock( item );
                        $.ipsoclocker.locker.log( item, 'facebooklike' );
                        $.ipsoclocker.locker.setCookie( item );
                    }
                });
            },
            
            createButton: function () {

                this.button = $("<div class='fake-fb-like'></div>");
                   
                this.wrap = $("<div class='ipsl-social-button ipsl-facebook-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                            
                if (this.options.count == 'none') {
                    this.wrap.addClass('ipsl-facebook-like-count-none');
                    this.wrap.addClass('ipsl-facebook-like-' + this.options.lang);
                }

                this.button.data('facebook-widget', this);
                this.button.attr("data-show-faces", false);
                this.button.attr("data-send", false); 
                
                if (this.options.url) this.button.attr("data-href", this.options.url);
                if (this.options.font) this.button.attr("data-font", this.options.font);
                if (this.options.colorScheme) this.button.attr("data-colorscheme", this.options.colorScheme);
                if (this.options.ref) this.button.attr("data-ref", this.options.ref);
                if (this.options.width) this.button.attr("data-width", this.options.width);
                if (this.options.layout) this.button.attr("data-layout", this.options.layout);
                if (this.options.verbToDisplay) this.button.attr("data-action", this.options.verbToDisplay);
            },

            getHtmlToRender: function () {
                return this.wrap;
            }
        
        },
        
        //Facebook share button
        facebookshare: {
        
            options: {},

            defaults: {
                
                url:            null,
                appId:          0,
                layout:         'standard',
                count:          'standard',
                name:           null,
                caption:        null,
                description:    null,
                image:          null,
                
                unlock:         null
            },

            create: function () {
                var self = this;

                this.prepareOptions();

                this.element.data('ipsoclocker-facebookButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("facebook", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values   = $.extend({}, this.defaults);
                this.options = $.extend(values, this.options);
                this.url     = (!this.options.url) ? window.location.href : this.options.url;
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {
                var count = 0;
                var self = this;
                
                this.button = $("<div class='ipsl-facebook-share ipsl-facebook-layout-" + this.options.layout + "'></div>");
                this.button.append($("<a href='#' class='ipsl-facebook-share-icon'></a>"));
                this.button.append($("<div class='ipsl-facebook-share-count'>" + count + "</div>"));
                this.button.data('facebook-widget', this);
                
                this.wrap = $("<div class='ipsl-social-button ipsl-facebook-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                            
                if (this.options.count == 'none') {
                    this.button.addClass('ipsl-facebook-share-count-none');
                }
                            
               this.button.click(function(){
                FB.ui(
                   {
                     method: 'feed',
                     name: self.name,
                     link: self.url,
                     picture: self.image,
                     caption: self.caption,
                     description: self.description
                   },
                   function(response) {
                     if (response && response.post_id) {
                        self.button.find('.ipsl-facebook-share-count').text(self.getCountLabel(count++));
                        
                        var widget = self.element;
                        var item   = widget.parents( '.iplock-item' );
                        $.ipsoclocker.locker.unlock( item );
                        $.ipsoclocker.locker.log( item, 'facebookshare' );
                        $.ipsoclocker.locker.setCookie( item );
                     }
                   }
                );
                    
                return false;
               });
               
                $.ipsoclocker.connector.connect("facebook", this.options, function (api) {
                    window.FB.api("/", { "id": self.url }, function (response) {
                        if (response.error) return;
                        count = self.getCountLabel( response.shares || count );
                        self.button.find('.ipsl-facebook-share-count').text(count);
                    });
                });
            },
            
            getCountLabel: function(count) {
                if ( count >= 1000 ) return Math.floor( count / 1000 ) + "K";
                return count;
            },

            getHtmlToRender: function () {
                return this.wrap;
            }
        
        },
        
        //Google plus button
        googleplus: {
        
            options: {},

            defaults: {
                
                url:             null,
                type:            null,
                lang:            'en-US',
                size:            null,
                annotation:      null,
                width:           null,
                align:           "left",
                expandTo:        "",
                recommendations: true,
                
                unlock:          null
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();

                this.element.data('ipsoclocker-googleButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("google", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values   = $.extend({}, this.defaults);
                this.options = $.extend(values, this.options);
                this.url     = (!this.options.url) ? window.location : this.options.url;
            },

            setupEvents: function () {
                var self = this;

                $(document).bind('gl-plus', function (e, url) {
                    $(".gc-bubbleDefault").hide();
                    if ((self.url == url || (self.url + '/') == url)) {
                        var widget = self.element;
                        var item   = widget.parents( '.iplock-item' );
                        $.ipsoclocker.locker.unlock( item );
                        $.ipsoclocker.locker.log( item, 'googleplus' );
                        $.ipsoclocker.locker.setCookie( item );
                    }
                });
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {

                this.button = $("<div class='fake-g-plusone'></div>");
                
                this.wrap = $("<div class='ipsl-social-button ipsl-google-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                
                this.button.data('google-widget', this);

                if (this.options.url) this.button.attr("data-href", this.options.url);
                if (this.options.size) this.button.attr("data-size", this.options.size);
                if (this.options.annotation) this.button.attr("data-annotation", this.options.annotation);
                if (this.options.align) this.button.attr("data-align", this.options.align);
                if (this.options.expandTo) this.button.attr("data-expandTo", this.options.expandTo);
                if (this.options.recommendations) this.button.attr("data-recommendations", this.options.recommendations);
            },

            getHtmlToRender: function () {
                return this.wrap;
            }
        
        },
        
        //Google plus button
        googleshare: {
        
            options: {},

            defaults: {
                
                url:             null,
                type:            null,
                lang:            'en-US',
                size:            null,
                annotation:      null,
                width:           null,
                align:           "left",
                expandTo:        "",
                recommendations: true,
                
                unlock:          true
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();

                this.element.data('ipsoclocker-googleButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("google", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values   = $.extend({}, this.defaults);
                this.options = $.extend(values, this.options);
                this.url     = (!this.options.url) ? window.location : this.options.url;
            },

            setupEvents: function () {
                var self = this;
                
                $(document).bind('gl-share', function (e, url) {
                
                    $(".gc-bubbleDefault").hide();
                    if ( self.options.unlock && (self.url == url || (self.url + '/') == url)) {
                        var widget = self.element;
                        var item   = widget.parents( '.iplock-item' );
                        $.ipsoclocker.locker.unlock( item );
                        $.ipsoclocker.locker.log( item, 'googleshare' );
                        $.ipsoclocker.locker.setCookie( item );
                        
                        self.options.unlock = false;
                    }
                });
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {

                this.button = $("<div class='fake-g-share'></div>");
                
                this.wrap = $("<div class='ipsl-social-button ipsl-google-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                
                this.button.data('google-widget', this);

                if (this.options.url) this.button.attr("data-href", this.options.url);
                if (this.options.size) this.button.attr("data-size", this.options.size);
                if (this.options.annotation) this.button.attr("data-annotation", this.options.annotation);
                if (this.options.align) this.button.attr("data-align", this.options.align);
                if (this.options.expandTo) this.button.attr("data-expandTo", this.options.expandTo);
                if (this.options.recommendations) this.button.attr("data-recommendations", this.options.recommendations);
            },

            getHtmlToRender: function () {
                return this.wrap;
            }
        
        },
        
        //Twitter button
        twittertweet: {

            options: {},

            defaults: {

                url:            'http://twitter.com/iznyn',
                type:           null,
                text:           null,
                via:            null,
                showScreenName: false,
                related:        null,
                count:          'horizontal',
                showCount:      true,
                lang:           'en',
                counturl:       null,
                size:           'large',
                
                // unlock event
                unlock:         null
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();

                this.element.data('ipsoclocker-twitterButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("twitter", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values = $.extend({}, this.defaults);

                for (var prop in this._defaults) {
                    if (this.element.data(prop) !== undefined) values[prop] = this.element.data(prop);
                }

                this.options = $.extend(values, this.options);

                if (!this.options.url && $("link[rel='canonical']").length > 0)
                    this.options.url = $("link[rel='canonical']").attr('href');
                
                this.url = this.options.url || window.location.href;

            },

            setupEvents: function () {
                var self = this;

                $(document).bind('tw-tweet', function (e, target, data) {
                    
                    //var url  = $(target).parent().attr('data-url-to-compare');
                    var item = $(target).parents( '.iplock-item' );
                    $.ipsoclocker.locker.unlock( item );
                    $.ipsoclocker.locker.log( item, 'twittertweet' );
                    $.ipsoclocker.locker.setCookie( item );
                });
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {

                // What will title be used?
                var title = 'Tweet';

                this.button = $("<a href='https://twitter.com/share'>" + title + "</a>");
                this.button.data('twitter-widget', this);
                
                this.wrap = $("<div class='ipsl-social-button ipsl-twitter-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                
                this.wrap.addClass('ipsl-twitter-tweet');
                this.button.addClass('twitter-share-button');

                this.button.attr("data-url", this.url);

                this.button.attr("data-show-count", this.options.showCount);
                if (this.options.via) this.button.attr("data-via", this.options.via);
                if (this.options.text) this.button.attr("data-text", this.options.text);
                if (this.options.related) this.button.attr("data-related", this.options.related);
                if (this.options.count) this.button.attr("data-count", this.options.count);
                if (this.options.showCount) this.button.attr("data-show-count", this.options.showCount); 
                if (this.options.lang) this.button.attr("data-lang", this.options.lang);
                if (this.options.counturl) this.button.attr("data-counturl", this.options.counturl);
                if (this.options.hashtags) this.button.attr("data-hashtags", this.options.hashtags);
                if (this.options.alignment) this.button.attr("data-alignment", this.options.alignment);
                if (this.options.size) this.button.attr("data-size", this.options.size);
                if (this.options.dnt) this.button.attr("data-dnt", this.options.dnt);
                if (this.options.showScreenName) this.button.attr("data-show-screen-name", this.options.showScreenName);
                
                this.wrap.attr('data-url-to-compare', this.url);
            },

            getHtmlToRender: function () {
                return this.button;
            }
        
        },
        
        //Twitter button
        twitterfollow: {

            options: {},

            defaults: {

                url:            'http://twitter.com/iznyn',
                type:           null,
                text:           null,
                via:            null,
                showScreenName: false,
                related:        null,
                count:          'horizontal',
                showCount:      true,
                lang:           'en',
                counturl:       null,
                size:           'large',
                
                // unlock event
                unlock:         null
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();

                this.element.data('ipsoclocker-twitterButton', this);
                this.createButton();

                $.ipsoclocker.connector.connect("twitter", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values = $.extend({}, this.defaults);

                for (var prop in this._defaults) {
                    if (this.element.data(prop) !== undefined) values[prop] = this.element.data(prop);
                }

                this.options = $.extend(values, this.options);

                if (!this.options.url && $("link[rel='canonical']").length > 0)
                    this.options.url = $("link[rel='canonical']").attr('href');
                
                this.url = this.options.url || window.location.href;

            },

            setupEvents: function () {
                var self = this;

                $(document).bind('tw-follow', function (e, target, data) {
                
                    var item = $(target).parents( '.iplock-item' );
                    $.ipsoclocker.locker.unlock( item );
                    $.ipsoclocker.locker.log( item, 'twitterfollow' );
                    $.ipsoclocker.locker.setCookie( item );
                });   
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {

                // What will title be used?
                var title = 'Follow Me';
                if (!this.options.url) title = "[Error] Setup an URL of your Twitter account.";

                this.button = $("<a href='https://twitter.com/share'>" + title + "</a>");
                this.button.data('twitter-widget', this);
                
                this.wrap = $("<div class='ipsl-social-button ipsl-twitter-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);
                
                this.wrap.addClass('ipsl-twitter-follow');
                this.button.addClass('twitter-follow-button');

                this.button.attr('href', this.url);

                this.button.attr("data-show-count", this.options.showCount);
                if (this.options.via) this.button.attr("data-via", this.options.via);
                if (this.options.text) this.button.attr("data-text", this.options.text);
                if (this.options.related) this.button.attr("data-related", this.options.related);
                if (this.options.count) this.button.attr("data-count", this.options.count);
                if (this.options.showCount) this.button.attr("data-show-count", this.options.showCount); 
                if (this.options.lang) this.button.attr("data-lang", this.options.lang);
                if (this.options.counturl) this.button.attr("data-counturl", this.options.counturl);
                if (this.options.hashtags) this.button.attr("data-hashtags", this.options.hashtags);
                if (this.options.alignment) this.button.attr("data-alignment", this.options.alignment);
                if (this.options.size) this.button.attr("data-size", this.options.size);
                if (this.options.dnt) this.button.attr("data-dnt", this.options.dnt);
                if (this.options.showScreenName) this.button.attr("data-show-screen-name", this.options.showScreenName);
                
                this.wrap.attr('data-url-to-compare', this.url);
            },

            getHtmlToRender: function () {
                return this.button;
            }
        
        },
        
        //LinkedIn button
        linkedin: {

            options: {},

            defaults: {

                url:        null,
                counter:    'right',
                
                // unlock event
                unlock:     null
            },

            create: function () {
                var self = this;

                this.prepareOptions();
                this.setupEvents();
                this.createButton();
                this.element.data('ipsoclocker-linkedinButton', this);
                
                $.ipsoclocker.connector.connect("linkedin", this.options, function (api) {
                    api.render(self.element);
                });
            },

            prepareOptions: function () {

                var values = $.extend({}, this.defaults);

                for (var prop in this._defaults) {
                    if (this.element.data(prop) !== undefined) values[prop] = this.element.data(prop);
                }

                this.options = $.extend(values, this.options);
                this.url = this.options.url || window.location.href;

            },

            setupEvents: function () {
                var self = this;

                $(document).bind('ln-share', function (e, url) {
                
                    var widget = self.element;
                    var item = widget.parents( '.iplock-item' );
                    $.ipsoclocker.locker.unlock( item );
                    $.ipsoclocker.locker.log( item, 'linkedinshare' );
                    $.ipsoclocker.locker.setCookie( item );
                });
            },

            /**
            * Generates an html code for the button using specified options.
            */
            createButton: function () {

                // What will title be used?
                
                this.button = $('<script type="IN/Share"></script>');
                this.wrap = $("<div class='ipsl-social-button ipsl-linkedin-button'></div>")
                            .appendTo(this.element)
                            .append(this.button);

                if (this.options.counter) this.button.attr("data-counter", this.options.counter);
                if (this.options.url) this.button.attr("data-url", this.url);
            },

            getHtmlToRender: function () {
                return this.button;
            }
        
        },
        
    
    };
    
    $.ipsoclocker.connector = {
    
        api: [

        // --
        // Facebook 
        // --
        {
            name: 'facebook',
            url: '//connect.facebook.net/{lang}/all.js',
            scriptId: 'facebook-jsapi',
            hasParams: true,
            isRender: true,

            isLoaded: function () {
                return (typeof (window.FB) === "object");
            },

            pre: function () {

                // root for facebook api
                $("#fb-root").length == 0 && $("<div id='fb-root'></div>").appendTo($("body"));

                // sets api language
                var lang = "en_US";
                this.url = this.url.replace("{lang}", lang);
            },

            createEvents: function (isLoaded) {
                var self = this;
                
                var load = function () {

                    window.FB.init({
                        appId: (self.options && self.options.appId) || null,
                        status: true,
                        cookie: true,
                        xfbml: true
                    });

                    window.FB.Event.subscribe('edge.create', function (response) {
                        $(document).trigger('fb-like', [response]);
                    });

                    // The initialization is executed only one time.
                    // Any others attempts will call an empty function.
                    window.FB.init = function () { };
                    $(document).trigger(self.name + '-init');
                };

                if (isLoaded) { load(); return; }

                if (window.fbAsyncInit) var predefined = window.fbAsyncInit;
                window.fbAsyncInit = function () {
                    load(); predefined && predefined();
                    window.fbAsyncInit = function () { };
                };
            },

            render: function (widget) {

                var api = widget.data('ipsoclocker-facebookButton');
                if (!api) return;

                var $html = api.getHtmlToRender();
                $('.fake-fb-like').addClass('fb-like');
                window.FB.XFBML.parse($html[0]);
            }
        },

        // --
        // Twitter 
        // --
        {
            name: 'twitter',
            url: '//platform.twitter.com/widgets.js',
            scriptId: 'twitter-wjs',
            hasParams: false,
            isRender: true,

            pre: function () {

                var canonical = ($("link[rel='canonical']").length > 0)
                        ? $("link[rel='canonical']").attr('href')
                        : null;

                $(".twitter-share-button").each(function (index, item) {
                    var $item = $(item);
                    var $target = $(item).parent();

                    if ($target.attr('data-url-to-compare')) return;

                    var url = $item.attr("data-url");
                    if (!url && canonical) url = canonical;
                    url = (!url) ? window.location : url;

                    $item.parent().attr('data-url-to-compare', url);
                });
            },

            isLoaded: function () {
                return (typeof (window.__twttrlr) !== "undefined");
            },

            createEvents: function (isLoaded) {
                var self = this;

                var load = function () {

                    window.twttr.events.bind('tweet', function (event) {
                        $(document).trigger('tw-tweet', [event.target, event.data]);
                    });

                    window.twttr.events.bind('follow', function (event) {
                        $(document).trigger('tw-follow', [event.target, event.data]);
                    });

                    $(document).trigger(self.name + '-init');
                };

                if (isLoaded) { load(); return; }

                if (!window.twttr) window.twttr = {};
                if (!window.twttr.ready) window.twttr = $.extend(window.twttr, { _e: [], ready: function (f) { this._e.push(f); } });
                
                twttr.ready(function (twttr) { load(); });
            },

            /**
            * A twitter buttons works by other way.
            * When the script loaded 
            */
            render: function (widget) {

                var api = widget.data('ipsoclocker-twitterButton');
                if (!api) return;

                var $html = api.getHtmlToRender().parent();
                var attemptCounter = 5;

                // Chrome fix
                // If there is SDK script on the same page that is loading now when a tweet button will not appear.
                // Setup special timeout function what will check 5 times when we can render the twitter button.
                var timoutFunction = function () {
                    if ($html.find('iframe').length > 0) return;

                    if (window.twttr.widgets && window.twttr.widgets.load) {
                        window.twttr.widgets.load($html[0]);
                        widget.trigger('tw-render');
                    } else {
                        if (attemptCounter <= 0) return;
                        attemptCounter--;

                        setTimeout(function () {
                            timoutFunction();
                        }, 1000);
                    }
                };

                timoutFunction();
            }
        },

        // --
        // Google 
        // --
        {
            name: 'google',
            url: '//apis.google.com/js/plusone.js',
            scriptId: 'google-jssdk',
            hasParams: true,
            isRender: true,

            pre: function () {

                // sets sdk language
                var lang = (this.options && this.options.lang) || "en";
                window.___gcfg = window.___gcfg || { lang: lang };

                window.ipsoclockerPlusOneCallback = function (data) {
                    if (data.state == "on") $(document).trigger('gl-plus', [data.href]);
                };
                
                window.ipsoclockerGoogleShareCallback = function (data) {
                    $(document).trigger('gl-share', [data.id]);
                };    
            },

            isLoaded: function () {
                return (typeof (window.gapi) === "object");
            },

            render: function (widget) {

                var api = widget.data('ipsoclocker-googleButton');
                
                if (!api) return;

                var self = this;

                setTimeout(function () {
                    var $html = api.getHtmlToRender();
                    
                    var plusone = $('.fake-g-plusone');
                    if ( plusone.length > 0 ) {
                        self._addCallbackToControl($html);
                        plusone.addClass('g-plusone');
                        window.gapi.plusone.go($html[0]);
                    }
                    
                    var share = $('.fake-g-share');
                    if ( share.length > 0 ) {
                        share.attr("data-onendinteraction", "ipsoclockerGoogleShareCallback");
                        share.addClass('g-plus').attr('data-action', 'share');

                        gapi.plus.render(share);
                    }
     
                }, 100);
            },

            _addCallbackToControl: function ($control) {

                var $elm = (!$control.is(".g-plusone")) ? $control.find(".fake-g-plusone") : $control;

                var callback = $elm.attr("data-callback");
                if (callback && callback != "ipsoclockerPlusOneCallback") {
                    var newCallback = "__plusone_" + callback;
                    window[newCallback] = function (data) {
                        window[callback](data);
                        window.ipsoclockerPlusOneCallback(data);
                    };
                    $elm.attr("data-callback", newCallback);
                } else {
                    $elm.attr("data-callback", "ipsoclockerPlusOneCallback");
                }
            }
        },
        
        // --
        // Linked In 
        // --
        {
            name: 'linkedin',
            url: '//platform.linkedin.com/in.js',
            scriptId: 'linkedin-jssdk',
            hasParams: false,
            isRender: true,

            pre: function () {

                window.ipsoclockerLinkedInShareCallback = function (data) {
                    $(document).trigger('ln-share', [data]);
                };
            },

            isLoaded: function () {
                return (typeof (window.IN) === "object");
            },

            render: function (widget) {

                var api = widget.data('ipsoclocker-linkedinButton');
                if (!api) return;

                setTimeout(function () {
                    var $html = api.getHtmlToRender();
                    $html.attr("data-onsuccess", "ipsoclockerLinkedInShareCallback");
                    IN.Init();
                }, 100);
            }
        }
        
        ],

        _ready: {},

        _connected: {},

        getAPI: function (name) {

            for (var index in this.api) if (this.api[index].name == name) return this.api[index];
            return null;
        },

        isConnected: function (api) {
            return ($("#" + api.scriptId).length > 0 || $("script[src='*" + api.url + "']").length > 0);
        },

        getLoadingScript: function (api) {
            var byId = $("#" + api.scriptId);
            var byScr = $("script[src='*" + api.url + "']");
            return (byId.length > 0) ? byId : byScr;
        },

        isLoaded: function (api) {
            return this.isConnected(api) && api.isLoaded && api.isLoaded();
        },

        connect: function (name, options, callback) {
            var self = this, api = this.getAPI(name);

            if (!api) {
                console && console.log('Invalide API name: ' + name);
                return;
            }

            api.options = options;

            // fire or bind callback
            if (callback) this._ready[name]
                    ? callback(api)
                    : $(document).bind(name + "-init", function () { callback(api); });

            if (this._connected[name]) return;

            // sets the default method if it's not specified
            if (!api.createEvents) {
                api.createEvents = function (isLoaded) {
                    var selfAPI = this;

                    var load = function () {
                        $(document).trigger(selfAPI.name + '-init');
                    };

                    if (isLoaded) { load(); return; }

                    $(document).bind(selfAPI.name + "-script-loaded", function () {
                        load();
                    });
                };
            }

            if (api.pre) api.pre();

            var loaded = this.isLoaded(api);
            var connected = this.isConnected(api);

            $(document).bind(name + "-init", function () { self._ready[name] = true; });

            // subscribes to events
            api.createEvents(loaded);

            // conencts api
            if (!connected) {

                var scriptConnection = function () {

                    var script = document.createElement('script');
                    script.type = 'text/javascript';
                    script.id = api.scriptId;
                    script.src = api.url;

                    var bodyElement = document.getElementsByTagName('body')[0];
                    bodyElement.appendChild(script);
                };

                api.isRender
                    ? scriptConnection()
                    : $(function () { $(function () { scriptConnection(); }); });
            }

            // subsribes to onload event
            if (!loaded) {

                var loadingScript = this.getLoadingScript(api)[0];

                if (loadingScript) {
                    loadingScript.onreadystatechange = loadingScript.onload = function () {
                        var state = loadingScript.readyState;
                        if ((!state || /loaded|complete/.test(state))) $(document).trigger(api.name + '-script-loaded');
                    };
                }
            }

            this._connected[name] = true;
        }
    };
    
    // Social button public function
    $.fn.ipsoclocker_facebook_like = function(){
    
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var layout  = button.data('layout');
            var href    = button.data('href');
            if ( layout ) {
                options.layout = layout;
            }
            if ( href ) {
                options.url = href;
            }
            options.appId  = button.data('appid');
            
            var factory = $.ipsoclocker.factory.facebooklike;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_facebook_share = function(){
    
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = button.data('href');
            if ( href ) {
                options.url = href;
            }
            options.layout = button.data('layout');
            options.appId  = button.data('appid');
            
            var factory = $.ipsoclocker.factory.facebookshare;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_twitter_tweet = function(){
    
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = $(this).data('href');
            if ( href ) {
                options.url = href;
            }
            options.size  = button.data('size');
            options.count = button.data('count');
            options.text  = button.data('text');
            
            var factory     = $.ipsoclocker.factory.twittertweet;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_twitter_follow = function(){
    
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = button.data('href');
            if ( href ) {
                options.url = href;
            }
            options.size  = button.data('size');
            options.count = button.data('count');
            options.text  = button.data('text');
            
            var factory     = $.ipsoclocker.factory.twitterfollow;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_google_plus = function(){
        
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = button.data('href');
            if ( href ) {
                options.url = href;
            }
            options.size  = button.data('size');
            options.annotation = 'bubble';
            
            var factory  = $.ipsoclocker.factory.googleplus;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_google_share = function(){
    
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = button.data('href');
            if ( href ) {
                options.url = href;
            }
            options.annotation = button.data('annotation');
            
            var factory  = $.ipsoclocker.factory.googleshare;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    $.fn.ipsoclocker_linkedin_share = function(){
        
        $(this).each( function() {
        
            var button  = $(this);
            var options = {};
            var href    = button.data('href');
            if ( href ) {
                options.url = href;
            }
            options.counter = button.data('counter');
            
            var factory  = $.ipsoclocker.factory.linkedin;
            factory.element = button;
            factory.options = options;
            factory.create();
            button.append( factory.getHtmlToRender() );
        });
    };
    
    // Loader
    $(document).ready(function($) {
        
        //Locker Init
        $.ipsoclocker.options = $.extend($.ipsoclocker.options,iplocker_settings);
        
        //Facebook like button
        $( '.ipsl-socbtn-fblike' ).ipsoclocker_facebook_like();
    
        //Facebook share button
        $( '.ipsl-socbtn-fbshare' ).ipsoclocker_facebook_share();
    
        //Twitter tweet button
        $( '.ipsl-socbtn-twtweet' ).ipsoclocker_twitter_tweet();
    
        //Twitter share button
        $( '.ipsl-socbtn-twfollow' ).ipsoclocker_twitter_follow();
    
        //Google plus button
        $( '.ipsl-socbtn-gplus' ).ipsoclocker_google_plus();
    
        //Google share button
        $( '.ipsl-socbtn-gshare' ).ipsoclocker_google_share();
    
        //Linkedin share button
        $( '.ipsl-socbtn-inshare' ).ipsoclocker_linkedin_share();
        
        var ipsl_auto_unlock = function()
        {
            //close
            var ipsl_timer = null;
            $( '.ip-locker-close a' ).each( function(){
                var link = $(this);
                link.click( function(){
                    var object = link.parents( '.iplock-item' );
                    $.ipsoclocker.locker.unlock( object );
                    $.ipsoclocker.locker.log( object, 'close' );
                    if ( ipsl_timer ) {
                        clearTimeout( ipsl_timer );
                    }
                    return false;
                });
            });
            
            //timer
            $( '.ip-locker-timer' ).each( function(){
            
                var timer    = $(this);
                var interval = timer.data( 'interval' );
                var intNumb  = new Number( interval );
                var timeInt  = setInterval(function() {
                    var current  = $( '.ip-timer-second', timer ).text();
                    var number   = new Number( current );
                    if ( number > 0 ) {
                        $( '.ip-timer-second', timer ).text( number - 1 );
                    } else {
                        clearInterval(timeInt);
                    }
                }, 1000);
                
                ipsl_timer = setTimeout(function(){
                    var object = timer.parents( '.iplock-item' );
                    $.ipsoclocker.locker.unlock( object );
                    $.ipsoclocker.locker.log( object, 'timer' );
                    
                }, intNumb*1000);
            });
            
        };
        ipsl_auto_unlock();
    });
    
})(jQuery);